<template>
    <div>
        <h1>Кошик</h1>
        <p v-if="!basketData.length">До кошику ще нічого не додано</p>
        <BasketItem
            v-for="(item, index) in basketData"
            :key="item.id"
            :basket-item-data="item"
            @deleteFromBasket="deleteBasketItem(index)"
            @increment="increment(index)"
            @decrement="decrement(index)"
        />
        <div class="basket_total">
            <p>Всього: </p>
            <p> {{ basketTotal }} грн.</p>
        </div>
    </div>
</template>

<script>
import BasketItem from './BasketItem.vue'
import {mapActions} from "vuex";

export default {
    name: "Basket",
    components: {
        BasketItem,
    },
    props: {
        basketData: {
            type: Array,
            default() {
                return []
            }
        }
    },
    computed: {
        basketTotal() {
            let result = [];
            if(this.basketData.length){
                for(let item of this.basketData) {
                    result.push(item.price * item.quantity);
                }
                result = result.reduce(function (sum, el) {
                    return sum+el;
                })
                return result;
            }
            else return 0;
        }
    },
    methods: {
        ...mapActions([
            'deleteFromBasket',
            'incrementBasketItem',
            'decrementBasketItem'
        ]),
        deleteBasketItem(index) {
            this.deleteFromBasket(index);
        },
        increment(index) {
            this.incrementBasketItem(index);
        },
        decrement(index) {
            this.decrementBasketItem(index);
        }
    },
}
</script>

<style lang="scss">
    .basket_total {
        position: fixed;
        bottom: 0;
        right: 0;
        left: 0;
        padding: 16px;
        display: flex;
        justify-content: center;
        background-color: rgba(30,255,48,0.67);
        font-size: 20px;
    }
</style>
